/*
    The venvm is small webtool for manager virtualenv.
    Copyright (C) 2013  Rodrigo Pinheiro Matias <rodrigopmatias@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see {http://www.gnu.org/licenses/}.
*/

window.Container = {

    URL: {
        'pypi': 'https://pypi.python.org/pypi',
        'python': 'http://www.python.org/'
    },

    setLang: function(lang) {
        $.ajax({
            'beforeSend': function() {
                $('body .loading').removeClass('hidden');
            },
            'complete': function() {
                setTimeout(
                    function () {
                        $('body .loading').addClass('hidden');
                    },
                    250
                );
            },
            'url': '/language/' + lang,
            'crossDomain': false,
            'dataType': 'json',
            'success': function(data) {
                if(data.success)
                    location.reload(true)
                else
                    alert(data.message)
            }
        })
    },

    openInstall: function() {
        alert('not implemented');
    },

    displayInformation: function(name) {
        $('body .loading').removeClass('hidden');

        $('#dataview > div').load('/package/info/' + name, function() {
            setTimeout(
                function () {
                    $('body .loading').addClass('hidden');
                },
                250
            );
        });
    },

    refresh: function() {
        $('#listview').html('Carregando...');

        $('body .loading').removeClass('hidden');

        $('#listview').load('/package/list', function() {
            setTimeout(
                function () {
                    $('body .loading').addClass('hidden');
                },
                250
            );

            $('#listview .list-item').click(function() {
                $('#listview .list-item').removeClass('list-item-selected');
                $(this).addClass('list-item-selected');
                Container.displayInformation($(this).attr('data'));
            })
        })
    },

    sync: function(lang) {
        $.ajax({
            'beforeSend': function() {
                $('body .loading').removeClass('hidden');
            },
            'complete': function() {
                setTimeout(
                    function () {
                        $('body .loading').addClass('hidden');
                    },
                    250
                );
            },
            'url': '/sync',
            'crossDomain': false,
            'dataType': 'json',
            'success': function(data) {
                alert(data.message);
                Container.refresh();
            }
        })
    },

    render: function(destination, aref) {
        $('#container').load('/' + destination);

        $('#menu a.selected').removeClass('selected');
        $(aref).addClass('selected');

        return false;
    },

    open: function(destination, windowName) {
        window.open(Container.URL[destination], windowName);

        return false;
    }
}